atheneapp/__init__.py
from flask import Flask
from flask_sqlalchemy import SQLAlchemy
from flask_login import LoginManager

db = SQLAlchemy()
login_manager = LoginManager()


def create_app():
    # Create app
    app = Flask(__name__, instance_relative_config=False)
    app.config.from_object("config.Config")

    # Initialise plugins
    db.init_app(app)
    login_manager.init_app(app)

    with app.app_context():
        from . import auth, views
        from .assets import compile_static_assets

        # Register Blueprints
        app.register_blueprint(auth.auth_bp)
        # Normal Blueprints
        app.register_blueprint(views.views_bp)

        # Create Database Models
        db.create_all()

        # Compile static assets
        # if app.config["FLASK_ENV"] == "development":
        #     compile_static_assets(app)

    return app

atheneapp/auth.py
"""Routes for user authentication."""
from flask import Blueprint, flash, redirect, render_template, request, url_for
from flask_login import current_user, login_user

from . import login_manager
from .forms import LoginForm, SignupForm
from .models import User, db

# Blueprint Configuration
auth_bp = Blueprint(
    "auth_bp",
    __name__,
    template_folder="templates",
    static_folder="static"
)


@auth_bp.route("/signup/", methods=["GET", "POST"])
def signup():
    """
    User sign-up page.
    GET requests serve sign-up page.
    POST requests validate form & user creation.
    """
    form = SignupForm()
    if form.validate_on_submit():
        existing_user = User.query.filter_by(email=form.email.data).first()
        if existing_user is None:
            user = User(
                name=form.name.data,
                email=form.email.data
            )
            user.set_password(form.password.data)
            db.session.add(user)
            # Création de l'utilisateur
            db.session.commit()
            # Connexion de l'utilisateur
            login_user(user)
            return redirect(url_for("views_bp.index"))
        flash("Un utilisateur existe déjà avec cette adresse mail.")
    return render_template(
        "signup.jinja2",
        title="Créer un compte.",
        form=form,
        template="signup-page",
        body="Sign up for a user account.",
    )


@auth_bp.route("/")
@auth_bp.route("/login/", methods=["GET", "POST"])
def login():
    """
    Log-in page for registered users.
    GET requests serve Log-in page.
    POST requests validate and redirect user to dashboard.
    """
    # Ignore la page si l'utilisateur est déjà connecté
    if current_user.is_authenticated:
        return redirect(url_for("views_bp.index"))

    form = LoginForm()
    # Validate login attempt
    if form.validate_on_submit():
        user = User.query.filter_by(email=form.email.data).first()
        if user and user.check_password(password=form.password.data):
            login_user(user)
            next_page = request.args.get("next")
            return redirect(next_page or url_for("views_bp.index"))
        flash("Invalid username/password combination")
        return redirect(url_for("auth_bp.login"))
    return render_template(
        "login.jinja2",
        form=form,
        title="Log in.",
        template="login-page",
        body="Log in with your User account.",
    )


@login_manager.user_loader
def load_user(user_id):
    """Check if user is logged-in upon page load."""
    if user_id is not None:
        return User.query.get(user_id)
    return None


@login_manager.unauthorized_handler
def unauthorized():
    """Redirect unauthorized users to Login page."""
    flash("You must be logged in to view that page.")
    return redirect(url_for("auth_bp.login"))

atheneapp/views.py
"""Flask app normal routes."""
from flask import render_template, request, url_for, redirect, Blueprint
from flask_login import current_user, login_required, logout_user
from flask_sqlalchemy import SQLAlchemy
from .queues import file_creation

from . import login_manager
from .forms import VmForm
from .models import Vm, db

# Blueprint
views_bp = Blueprint(
    'views_bp',
    __name__,
    template_folder="templates",
    static_folder="static"
)


# Routes
@views_bp.route('/index/')
@login_required
def index():
    """Logged-in User Dashboard."""
    return render_template(
        "index.jinja2",
        title="AtheneApp.",
        template="dashboard-template",
        current_user=current_user,
        body="Vous êtes connecté !",
    )


@views_bp.route("/logout")
@login_required
def logout():
    """User log-out logic."""
    logout_user()
    return redirect(url_for("auth_bp.login"))


@views_bp.route('/formulaire/', methods=["GET", "POST"])
@login_required
def formulaire():
    # Page du formulaire
    form = VmForm()

    return render_template(
        "formulaire.jinja2",
        title="Formulaire",
        form=form,
        template="signup-page",
        body="Remplir le formulaire de création de VM."
    )


@views_bp.route('/formulaire/init/', methods=["GET", "POST"])
@login_required
def creation():
    # Traitement du Formulaire
    if request.method == 'POST':
        # Datas
        nom = request.form["name"]
        os = request.form["os"]
        stockage = request.form["stockage"]
        cpu_number = request.form["cpu"]
        # ram_memory = request.form["ram"]
        # netcard_number = request.form["netcard"]
        # groupe = request.form["groupe"]
        # hyperviseur = request.form["hyperviseur"]

        newVm = Vm(name=nom, memory=stockage, environment=os, vcpu=cpu_number)
        db.session.add(newVm)
        db.session.commit()

        # VM format JSON
        data = '{"nom":"'+nom+'", ' \
                '"groupe":"'+os+'", ' \
                '"memoire rom":"'+stockage+'", ' \
                '"nombre de CPU":"' + cpu_number + '"}'
                                                   # ',' \
                # '"memoire ram":"'+ram_memory+'",' \
                # '"nombre de carte réseau":"'+netcard_number+'",' \
                # '"environnement":"'+groupe+'",' \
                # '"hyperviseur":"'+hyperviseur+'"}'

        print(data)

        # file_creation.queue_creation(data)

        return data

atheneapp/templates/analytics.jinja2
<script type="text/javascript">
  var _gauges = _gauges || [];
  (function() {
    var t   = document.createElement('script');
    t.type  = 'text/javascript';
    t.async = true;
    t.id    = 'gauges-tracker';
    t.setAttribute('data-site-id', '5eb66f54d96b5b0e0ead80ed');
    t.setAttribute('data-track-path', 'https://track.gaug.es/track.gif');
    t.src = 'https://d2fuc4clr7gvcn.cloudfront.net/track.js';
    var s = document.getElementsByTagName('script')[0];
    s.parentNode.insertBefore(t, s);
  })();
</script>

atheneapp/templates/formulaire.jinja2
{% extends "layout.jinja2" %}

{% block pagestyles %}
  <link href="{{ url_for('static', filename='dist/css/account.css') }}" rel="stylesheet" type="text/css">
{% endblock %}

{% block content %}
    <div class="form-wrapper">

    <div class="logo">
      <img src="{{ url_for('static', filename='dist/img/logo.png') }}" alt="logo"/>
    </div>

    {% for message in get_flashed_messages() %}
        <div class="alert alert-warning">
            <button type="button" class="close" data-dismiss="alert">&times;</button>
            {{ message }}
        </div>
    {% endfor %}

    <h1>Formulaire de création de machine virtuelle</h1>

    <form method="POST" action="/formulaire/init/">
        {{ form.csrf_token }}
        <fieldset class="name">
            {{ form.name.label }}
            {{ form.name(placeholder='Machine virtuel') }}
            {% if form.name.errors %}
                <ul class="errors">
                    {% for error in form.name.errors %}
                        <li>{{ error }}</li>{% endfor %}
                </ul>
            {% endif %}
        </fieldset>
        <fieldset class="stockage">
            {{ form.stockage.label }}
            {{ form.stockage(placeholder='Mémoire de stockage') }}
            {% if form.stockage.errors %}
                <ul class="errors">
                    {% for error in form.stockage.errors %}
                        <li>{{ error }}</li>{% endfor %}
                </ul>
            {% endif %}
        </fieldset>
        <fieldset class="os">
            {{ form.os.label }}
            {{ form.os(placeholder='Environnement') }}
            {% if form.os.errors %}
                <ul class="errors">
                    {% for error in form.os.errors %}
                        <li>{{ error }}</li>{% endfor %}
                </ul>
            {% endif %}
        </fieldset>
        <fieldset class="cpu">
            {{ form.cpu.label }}
            {{ form.cpu(placeholder='Nombre de CPU') }}
            {% if form.cpu.errors %}
                <ul class="errors">
                    {% for error in form.cpu.errors %}
                        <li>{{ error }}</li>{% endfor %}
                </ul>
            {% endif %}
        </fieldset>
{#        <fieldset class="ram">#}
{#            {{ form.ram.label }}#}
{#            {{ form.ram(placeholder='Mémoire ram') }}#}
{#            {% if form.ram.errors %}#}
{#                <ul class="errors">#}
{#                    {% for error in form.ram.errors %}#}
{#                        <li>{{ error }}</li>{% endfor %}#}
{#                </ul>#}
{#            {% endif %}#}
{#        </fieldset>#}
{#        <fieldset class="groupe">#}
{#            {{ form.groupe.label }}#}
{#            {{ form.groupe(placeholder='Groupe') }}#}
{#            {% if form.groupe.errors %}#}
{#                <ul class="<errors></errors>">#}
{#                    {% for error in form.groupe.errors %}#}
{#                        <li>{{ error }}</li>{% endfor %}#}
{#                </ul>#}
{#            {% endif %}#}
{#        </fieldset>#}
{#        <fieldset class="netcard">#}
{#            {{ form.netcard.label }}#}
{#            {{ form.netcard(placeholder='Nombre de cartes réseau') }}#}
{#            {% if form.netcard.errors %}#}
{#                <ul class="errors">#}
{#                    {% for error in form.netcard.errors %}#}
{#                        <li>{{ error }}</li>{% endfor %}#}
{#                </ul>#}
{#            {% endif %}#}
{#        </fieldset>#}
{#        <fieldset class="hyperviseur">#}
{#            {{ form.hyperviseur.label }}#}
{#            {{ form.hyperviseur(placeholder='Hyperviseur de rattachement') }}#}
{#            {% if form.hyperviseur.errors %}#}
{#                <ul class="errors">#}
{#                    {% for error in form.hyperviseur.errors %}#}
{#                        <li>{{ error }}</li>{% endfor %}#}
{#                </ul>#}
{#            {% endif %}#}
{#        </fieldset>#}
        <div class="submit-button">
            {{ form.submit }}
        </div>

    </form>
  </div>
{% endblock %}

atheneapp/templates/index.jinja2
{% extends "layout.jinja2" %}

{% block pagestyles %}
  <link href="{{ url_for('static', filename='dist/css/dashboard.css') }}" rel="stylesheet" type="text/css">
  <link rel="stylesheet" href="https://use.typekit.net/sus7rlu.css">
{% endblock %}

{% block content %}
  <h1>{{ body }}</h1>

  {% if current_user.is_authenticated %}
    <p>Bonjour {{ current_user.name }}</p>
      <p>Bienvenue sur le site d'Athène</p>
      <a href="{{ url_for('views_bp.formulaire') }}">Créer une VM</a>
      <a href="{{ url_for('views_bp.logout') }}">Se déconnecter</a>
  {% endif %}

{% endblock %}

atheneapp/templates/init.html
{% extends "layout.jinja2" %}

{% block pagestyles %}
  <link href="{{ url_for('static', filename='dist/css/account.css') }}" rel="stylesheet" type="text/css">
{% endblock %}

atheneapp/templates/layout.jinja2
<!DOCTYPE html>
<html lang="en">

<head>
  <meta http-equiv="X-UA-Compatible" content="IE=edge"/>
  <title>{{ title }}</title>
  <meta name="viewport" content="width=device-width, initial-scale=1.0, viewport-fit=cover"/>
  <meta name="theme-color" content="#5eb9d7"/>
  <link rel="shortcut icon" href="{{ url_for('static', filename='dist/img/favicon.png') }}" type="image/x-icon"/>
  <link href="https://fonts.googleapis.com/css?family=Poppins:200,300,500" rel="stylesheet"/>
  {% block pagestyles %}{% endblock %}
</head>

<body class="{{ template }}">
<div class="container">
  {% block content %}{% endblock %}
</div>
<script src="{{ url_for('static', filename='dist/js/main.min.js') }}"></script>
{% block additionalscripts %}{% endblock %}
{% include 'analytics.jinja2' %}
</body>

</html>

atheneapp/templates/login.jinja2
{% extends "layout.jinja2" %}

{% block pagestyles %}
  <link href="{{ url_for('static', filename='dist/css/account.css') }}" rel="stylesheet" type="text/css">
{% endblock %}

{% block content %}
  <div class="form-wrapper">

    <div class="logo">
      <img src="{{ url_for('static', filename='dist/img/logo.png') }}" alt="logo"/>
    </div>

    {% for message in get_flashed_messages() %}
      <div class="alert alert-warning">
        <button type="button" class="close" data-dismiss="alert">&times;</button>
        {{ message }}
      </div>
    {% endfor %}

    <h1>Connexion</h1>

    <form method="POST" action="/login">
      {{ form.csrf_token }}

      <fieldset class="email">
        {{ form.email.label }}
        {{ form.email(placeholder='youremail@example.com') }}
        {% if form.email.errors %}
          <ul class="errors">
            {% for error in form.email.errors %}
              <li>{{ error }}</li>{% endfor %}
          </ul>
        {% endif %}
      </fieldset>

      <fieldset class="password">
        {{ form.password.label }}
        {{ form.password }}
        {% if form.email.errors %}
          <ul class="errors">
            {% for error in form.password.errors %}
              <li>{{ error }}</li>{% endfor %}
          </ul>
        {% endif %}
      </fieldset>

      <div class="submit-button">
        {{ form.submit }}
      </div>

      <div class="login-signup">
        <span>Vous n'avez pas de compte ? <a href="{{ url_for('auth_bp.signup') }}">Inscription</a></span>
      </div>

    </form>
  </div>
{% endblock %}

atheneapp/templates/signup.jinja2
{% extends "layout.jinja2" %}

{% block pagestyles %}
  <link href="{{ url_for('static', filename='dist/css/account.css') }}" rel="stylesheet" type="text/css">
{% endblock %}

{% block content %}
  <div class="form-wrapper">

    <div class="logo">
      <img src="{{ url_for('static', filename='dist/img/logo.png') }}" alt="logo"/>
    </div>

    {% for message in get_flashed_messages() %}
      <div class="alert alert-warning">
        <button type="button" class="close" data-dismiss="alert">&times;</button>
        {{ message }}
      </div>
    {% endfor %}

    <h1>Inscription</h1>

    <form method="POST" action="/signup">
      {{ form.csrf_token }}

      <fieldset class="name">
        {{ form.name.label }}
        {{ form.name(placeholder='John Smith') }}
        {% if form.name.errors %}
          <ul class="errors">
            {% for error in form.name.errors %}
              <li>{{ error }}</li>{% endfor %}
          </ul>
        {% endif %}
      </fieldset>

      <fieldset class="email">
        {{ form.email.label }}
        {{ form.email(placeholder='youremail@example.com') }}
        {% if form.email.errors %}
          <ul class="errors">
            {% for error in form.email.errors %}
              <li>{{ error }}</li>{% endfor %}
          </ul>
        {% endif %}
      </fieldset>

      <fieldset class="password">
        {{ form.password.label }}
        {{ form.password }}
        {% if form.password.errors %}
          <ul class="errors">
            {% for error in form.password.errors %}
              <li>{{ error }}</li>{% endfor %}
          </ul>
        {% endif %}
      </fieldset>

      <fieldset class="confirm">
        {{ form.confirm.label }}
        {{ form.confirm }}
        {% if form.confirm.errors %}
          <ul class="errors">
            {% for error in form.confirm.errors %}
              <li>{{ error }}</li>{% endfor %}
          </ul>
        {% endif %}
      </fieldset>

      <div class="submit-button">
        {{ form.submit }}
      </div>

    </form>

    <div class="login-signup">
      <span>Vous avez déjà un compte ? <a href="{{ url_for('auth_bp.login') }}">Se connecter</a></span>
    </div>
  </div>
{% endblock %}